%MISCELANEOUS class definition
%
%   Usage:
%      miscellaneous=miscellaneous();

classdef miscellaneous
	properties (SetAccess=public) 
		notes = modelfield('default','','marshall',false);
		name  = modelfield('default','','marshall',true,'format','String');
		dummy = modelfield('default',NaN,'marshall',false);
	end
	methods
		function obj = miscellaneous(varargin) % {{{
			switch nargin
				case 0
					obj=setdefaultparameters(obj);
				case 1
					in=varargin{1};
					if (isa(in,'numeric') & in==0),
						% requesting templates do nothing
					else
						error('constructor not supported');
					end 
				otherwise
					error('constructor not supported');
			end
		end % }}}
		function checkconsistency(obj,md,solution,analyses) % {{{

			checkfield(md,'miscellaneous.name','empty',1);

		end % }}}
		function obj = setdefaultparameters(obj) % {{{

			%first, use the defaults provided by the properties definition above. 
			fieldnames=fields(obj);
			for i=1:length(fieldnames),
				fieldname=fieldnames{i};
				obj.(fieldname)=obj.(fieldname).default;
			end
		end % }}}
		function disp(obj) % {{{
			disp(sprintf('   miscellaneous parameters:'));

			fielddisplay(obj,'notes','notes in a cell of strings');
			fielddisplay(obj,'name','model name');
			fielddisplay(obj,'dummy','empty field to store some data');

		end % }}}
	end
end
